/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by client-gen. DO NOT EDIT.

package v1beta1

import (
	"net/http"

	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_controlplane/controlplane/v1beta1"
	"gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/generated-controlplane/clientset/versioned/scheme"
	rest "k8s.io/client-go/rest"
)

type ControlplaneV1beta1Interface interface {
	RESTClient() rest.Interface
	KubeadmControlPlanesGetter
	KubeadmControlPlaneTemplatesGetter
}

// ControlplaneV1beta1Client is used to interact with features provided by the controlplane.cluster.x-k8s.io group.
type ControlplaneV1beta1Client struct {
	restClient rest.Interface
}

func (c *ControlplaneV1beta1Client) KubeadmControlPlanes(namespace string) KubeadmControlPlaneInterface {
	return newKubeadmControlPlanes(c, namespace)
}

func (c *ControlplaneV1beta1Client) KubeadmControlPlaneTemplates(namespace string) KubeadmControlPlaneTemplateInterface {
	return newKubeadmControlPlaneTemplates(c, namespace)
}

// NewForConfig creates a new ControlplaneV1beta1Client for the given config.
// NewForConfig is equivalent to NewForConfigAndClient(c, httpClient),
// where httpClient was generated with rest.HTTPClientFor(c).
func NewForConfig(c *rest.Config) (*ControlplaneV1beta1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	httpClient, err := rest.HTTPClientFor(&config)
	if err != nil {
		return nil, err
	}
	return NewForConfigAndClient(&config, httpClient)
}

// NewForConfigAndClient creates a new ControlplaneV1beta1Client for the given config and http client.
// Note the http client provided takes precedence over the configured transport values.
func NewForConfigAndClient(c *rest.Config, h *http.Client) (*ControlplaneV1beta1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientForConfigAndClient(&config, h)
	if err != nil {
		return nil, err
	}
	return &ControlplaneV1beta1Client{client}, nil
}

// NewForConfigOrDie creates a new ControlplaneV1beta1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *ControlplaneV1beta1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new ControlplaneV1beta1Client for the given RESTClient.
func New(c rest.Interface) *ControlplaneV1beta1Client {
	return &ControlplaneV1beta1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1beta1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *ControlplaneV1beta1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
